/**
 * Copyright  2007 matsu@zuena.org.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.zuena.guiceex;

import org.aopalliance.intercept.MethodInterceptor;
import org.aopalliance.intercept.MethodInvocation;
import org.hibernate.Session;

/**
 * @author matsu@zuena.org
 */
public class Interceptor implements MethodInterceptor {
	public Object invoke(MethodInvocation invocation) throws Throwable {
		Session session = (Session) invocation.getArguments()[0];
		System.out.println("---pre process");
		session.beginTransaction();
		invocation.proceed();
		System.out.println("---after process");
		session.getTransaction().commit();
		return null;
	}
}
